# build_stamp
# tcl script to automatically create a verilog module to add
# build date and time to a project

# -----------------------------------------------------------
proc create_build_stamp {} {

# Date and Time are each 32 bit decimal numbers 
# Date format is yyyymmdd
# Time format is hhmmss (24 hour format)

	set Date [ clock format [ clock seconds ] -format %Y%m%d ]
	set Time [ clock format [ clock seconds ] -format %H%M%S ] 
# create a file
	set outputFileName "build_stamp.v"
	set outputFile [open $outputFileName "w"]
	
# write the file
	puts $outputFile "////////////////////////////////////////////////"
	puts $outputFile "// build_stamp"
	puts $outputFile "////////////////////////////////////////////////"
	puts $outputFile ""
	puts $outputFile "module build_stamp"
	puts $outputFile "("
	puts $outputFile "   output \[31:0\]  build_date,"
	puts $outputFile "   output \[31:0\]  build_time"
	puts $outputFile ");"
	puts $outputFile ""
	puts $outputFile "   assign build_date     =  32'd$Date;"
	puts $outputFile "   assign build_time     =  32'd$Time;"
	puts $outputFile ""
	puts $outputFile "endmodule"
	close $outputFile
}

create_build_stamp